# Requirements
1. pytorch >= 1.9.0
2. torchvision
3. numpy
4. tqdm

# Prepare Dataset

``python split_set.py --dataset [cifar10, cifar100] 
--num 5000 --class_num [10, 100]``


# Victim Model and Pretrained Model

put your victim model into folder 
``./models/[cifar10, cifar100]/``

put and rename your pretrained model into folder 
``./pretrained/tiny/[mobilenet, resnet, vgg, wrn]_pretrained/[mobilenet, resnet, vgg, wrn].pkl``

# Run Model Extraction Attack

``python extraction_attack.py --arch the architecture of the victim model
-- ext the architecture of the pretrained model
--dataset [cifar10, cifar100] --num 5000 --class_num [10, 100]
--save1 the checkpoint name for the victim model
--save the name you want to save your extracted model
--exp experiment name
--method BEST
--aug [0,1]``




